/// <reference types="node" />
import ProcessEnv = NodeJS.ProcessEnv;
import { SimpleGitTask } from './tasks/task';
export declare type GitExecutorEnv = ProcessEnv | undefined;
export declare type outputHandler = (command: string, stdout: NodeJS.ReadableStream, stderr: NodeJS.ReadableStream) => void;
export interface GitExecutorResult {
    stdOut: Buffer[];
    stdErr: Buffer[];
    exitCode: number;
}
export declare class GitExecutor {
    binary: string;
    cwd: string;
    env: GitExecutorEnv;
    outputHandler: outputHandler;
    private _chain;
    constructor(binary: string, cwd: string, env: GitExecutorEnv, outputHandler: outputHandler);
    push<R>(task: SimpleGitTask<R>): Promise<void | R>;
    private handleTaskData;
    private gitResponse;
}
